// Copyright (C) 2011-2014 by Maximilian Hönig
// This file is part of "DunGen - the Dungeongenerator".
// For conditions of distribution and use, see licence.txt provided together with DunGen.

#include "MaterialCaveMultiColor.h"
#include "MaterialCaveSingleColor.h"
#include "MaterialCorridor.h"
#include "MaterialProvider.h"

DunGen::CMaterialProvider::CMaterialProvider(irr::IrrlichtDevice* irrDevice_)
: MaterialCaveMultiColor(new CMaterialCaveMultiColor(irrDevice_))
, MaterialCaveSingleColor(new CMaterialCaveSingleColor(irrDevice_))
, MaterialCorridor(new CMaterialCorridor(irrDevice_))
{
}

DunGen::CMaterialProvider::~CMaterialProvider()
{
	delete MaterialCorridor;
	delete MaterialCaveSingleColor;
	delete MaterialCaveMultiColor;
}

irr::video::E_MATERIAL_TYPE DunGen::CMaterialProvider::GetMaterial( SMaterialType::Enum type_ )
{
	switch (type_)
	{
	case SMaterialType::CAVE_SINGLECOLOR:
		return MaterialCaveSingleColor->GetMaterial();
	case SMaterialType::CAVE_MULTICOLOR:
		return MaterialCaveMultiColor->GetMaterial();
	default:
		return MaterialCorridor->GetMaterial();
	}
}

void DunGen::CMaterialProvider::SetCaveColor(const irr::video::SColorf& color_)
{
	MaterialCaveSingleColor->SetColor(color_);
}